program stiff


  implicit DOUBLE PRECISION  (a-h,o-z)
  dimension a(2,2), aa(2,2), u(2), u_n(2)

  ifile = 10

  write(*,*) "Put method type (1=explixit), (2= implicit)"
  read(*,*) i_method

  write(*,*) "Put $b$"
  read(*,*) x_max

  write(*,*) "Put time step $h$"
  read(*,*) tau

  if(i_method .eq. 1) then
     print*,'Explicit Euler method'
  elseif(i_method .eq. 2) then
     print*,'Implicit Euler method'
  else
     print*,'Unknown method'
     stop
  endif

  print*,'Solution at interval  (0., ',x_max,')'
  print*,'step h = ',tau
  print*

  a(1,1) = 998.0D+00
  a(1,2) = 1998.0D+00
  a(2,1) = -999.0D+00
  a(2,2) = -1999.0D+00

  k_max = x_max/tau
  time = 0.

  !     IC
  u(1) = 1.0D+00
  u(2) = 0.0D+00

  open(ifile, file='u_h' , status='UNKNOWN')

  if(i_method .eq. 1) then
     write(ifile,*) 0., u(1), u(2), 0
     do i=1, k_max

        u_n(1) = u(1) + tau*(a(1,1)* u(1) + a(1,2)*u(2) )
        u_n(2) = u(2) + tau*(a(2,1)* u(1) + a(2,2)*u(2) )
        time = time + tau
        u(1) = u_n(1)
        u(2) = u_n(2)

        !write(*,*) time, u(1), u(2), i
        write(ifile,*) time, u(1), u(2), i
     enddo

  elseif(i_method .eq. 2) then

     write(ifile,*) 0., u(1), u(2), 0
     do i=1, k_max

        aa(1,1) = 1.D+00 - tau*a(1,1)
        aa(1,2) =  - tau*a(1,2)
        aa(2,1) =  - tau*a(2,1)
        aa(2,2) = 1.D+00 - tau*a(2,2)

        det = aa(1,1)*aa(2,2) - aa(1,2)*aa(2,1)

        det1 = u(1)*aa(2,2) - u(2)*aa(1,2)
        det2 = u(2)*aa(1,1) - u(1)*aa(2,1)

        u_n(1) = det1/det
        u_n(2) = det2/det

        time = time + tau
        u(1) = u_n(1)
        u(2) = u_n(2)


        !write(*,*) time, u(1), u(2), i
        write(ifile,*) time, u(1), u(2), i
     enddo

  endif

  close(ifile)

  print*,'Computation finished'
end program stiff
